@echo off

rem
rem @(#) Script mise-a-jour HPU (Windows)
rem
rem
rem Argument 1 : contexte  "INST" (installation) ou "UNINST" (desinstallation)
rem
rem
rem
rem Attention :
rem - La liste des fichiers a recopier dans le repertoire en vue de la 
rem   desinstallation est a modifier en cas d'ajout/suprpession de fichiers.
rem
rem
rem Notes :
rem
rem - Le script n'est pas compatible Win98/WinMe
rem   La version est identifiee mais le resultat n'est pas exploite actuellement.
rem   Lignes de commande incompatibles :
rem   - cd /d
rem   - rmdir /s/q 
rem   - for
rem
rem - La commande "echo/" ou "echo." permet d'afficher une ligne vide.
rem
rem
rem
rem - Fichiers generes/utilises : 
rem   trace_version.txt
rem   ligne.txt
rem   mot.txt
rem
rem

rem ### DEBUG ###
rem pause
rem ### FIN DEBUG ###

echo.

rem Controle arguments d'appel

if "%1" == "" goto ERR_PARAM
if "%1" == "" goto ERR_PARAM
if not "%2" == "" goto ERR_PARAM

set CONTEXT=%1




rem Localisation des variables d'environnement dans le script uniquement

setlocal



rem Obtention du repertoire ou se trouve le script de la mise-a-jour

rem Repertoire complet obtenu a partir du chemin complet du fichier de commande execute
set DIR_UPDATE=%~d0%~p0

rem Retrait du "\" en fin
rem Probleme eventuel si le resultat se reduit a la racine d'une unite disque
set DIR_UPDATE=%DIR_UPDATE:~0,-1%




rem ##########################
rem Identification version DOS
rem ##########################

rem L'identification de la version du DOS est uniquement indicative

:IDENT_DOS


set DOSVERSION=UNKNOWN

ver | find "MS-DOS Version 6.22" >NUL
if not errorlevel 1 set DOSVERSION=MSDOS622

ver | find "Windows 95" >NUL
if not errorlevel 1 set DOSVERSION=WIN95

ver | find "Windows 98" >NUL
if not errorlevel 1  set DOSVERSION=WIN98

ver | find "Windows Millennium">NUL
if not errorlevel 1 set DOSVERSION=WINME

ver | find "Windows NT" >NUL
if not errorlevel 1 set DOSVERSION=WINNT

ver | find "Windows 2000" >NUL
if not errorlevel 1 set DOSVERSION=WIN2000

ver | find "Windows XP" >NUL
if not errorlevel 1 set DOSVERSION=WINXP

rem if %DOSVERSION% == UNKNOWN goto ERR_DOS





rem ##############################
rem Configuration fichier de trace
rem ##############################

set FILE_TRACE=XXXX
if "%CONTEXT%"=="INST" set FILE_TRACE=%DIR_UPDATE%\trace_install_update_hpu.txt
if "%CONTEXT%"=="UNINST" set FILE_TRACE=%DIR_UPDATE%\trace_uninstall_update_hpu.txt
if "%FILE_TRACE%"=="XXXX" goto ERR_PAR1 

rem Vidage fichier de trace
echo\ > "%FILE_TRACE%"

date /t >> "%FILE_TRACE%"
time /t >> "%FILE_TRACE%"


rem Traces a present que le fichier de trace existe


echo DOS version            : %DOSVERSION%  >> "%FILE_TRACE%"
echo/  >> "%FILE_TRACE%"

echo/
echo Output of VER command  :  >> "%FILE_TRACE%"
ver  >> "%FILE_TRACE%"

echo.                          >> "%FILE_TRACE%"
echo DIR_UPDATE : %DIR_UPDATE% >> "%FILE_TRACE%"
echo.                          >> "%FILE_TRACE%"






echo/
echo/

rem ##################################################
rem Lecture du fichier des variables de la mise-a-jour
rem ##################################################


cd /d "%DIR_UPDATE%"



for /f "tokens=1-2 delims== " %%a in (
 update_variables.txt
) do set %%a=%%b



echo.                                            >> "%FILE_TRACE%"
echo UPDATE_LABEL        : %UPDATE_LABEL%        >> "%FILE_TRACE%"
echo UPDATE_TYPE         : %UPDATE_TYPE%         >> "%FILE_TRACE%"
echo VERSION_UPDATE      : %VERSION_UPDATE%      >> "%FILE_TRACE%"
echo VERSION_UPDATE_BASE : %VERSION_UPDATE_BASE% >> "%FILE_TRACE%"
echo UPDATE_OS           : %UPDATE_OS%           >> "%FILE_TRACE%"
echo.                                            >> "%FILE_TRACE%"

set UPDATE_CATEGORY=Update
if "%UPDATE_TYPE%"=="INTERIM_FIX" set UPDATE_CATEGORY=Interim Fix
if "%UPDATE_TYPE%"=="HOT_FIX" set UPDATE_CATEGORY=Hot Fix


rem ###################################
rem Controle existence/valeur de TOPHPU
rem ###################################

if "%TOPHPU%"=="" ( echo TOPHPU variable undefined 
 echo TOPHPU variable undefined >> "%FILE_TRACE%"
 exit /b 1)

if not "%TOPHPU%"=="" ( 
 echo TOPHPU variable defined: %TOPHPU% >> "%FILE_TRACE%")

dir "%TOPHPU%\*.*" >NUL 2>&1
if errorlevel 1 (echo Directory %TOPHPU% not found!
 echo Directory %TOPHPU% not found! >> "%FILE_TRACE%"
 exit /b 1)






rem #####################################
rem Recuperation du repertoire du plug-in
rem #####################################



rem Recuperation repertoire DB2 via la base de registres
rem
rem Fichier resultat_reg.txt temporaire a supprimer
rem

rem Recuperation dans "HKEY_LOCAL_MACHINE SOFTWARE\IBM\DB2" de "DB2 Path Name"

"%DIR_UPDATE%\getregistry" > resultat_reg.txt

if not "%errorlevel%"=="0" goto ERR_DB2_LOCATION
for /F "Tokens=*"  %%V in ('type resultat_reg.txt') do set DB2_INSTALL_DIR=%%V



echo.                                    >> "%FILE_TRACE%" 
echo DB2_INSTALL_DIR : %DB2_INSTALL_DIR% >> "%FILE_TRACE%"
echo.                                    >> "%FILE_TRACE%" 






rem Recuperation de la version de DB2 a partir de db2hpu.cfg

for /F "usebackq delims== tokens=2" %%i in (`findstr db2version "%TOPHPU%\cfg\db2hpu.cfg"`) do (
set LINE_DB2VERSION=%%i)

set DB2_DIR=XXXX
if "%LINE_DB2VERSION%"=="V7" set DB2_DIR=%DB2_INSTALL_DIR%\cc
if "%LINE_DB2VERSION%"=="V8" set DB2_DIR=%DB2_INSTALL_DIR%\tools
if "%DB2_DIR%"=="XXXX" goto ERR_DB2_VERSION

echo.                                    >> "%FILE_TRACE%"
echo LINE_DB2VERSION : %LINE_DB2VERSION% >> "%FILE_TRACE%"
echo DB2_DIR         : %DB2_DIR%         >> "%FILE_TRACE%"
echo.                                    >> "%FILE_TRACE%"





rem ############################################
rem Verification applicabilite de la mise-a-jour
rem ############################################


rem 
rem Recuperation du numero de version HPU
rem 

if "%CONTEXT%"=="INST" goto CHECK_INST_VERSION
if "%CONTEXT%"=="UNINST" goto CHECK_UNINST_VERSION
goto ERR_CONTEXT


:CHECK_INST_VERSION

rem
rem >>> Fichier temporaire trace_version.txt a supprimer !!!!
rem

rem Appel de db2hpu avec CALL sinon pas de continuation du script aprs

call db2hpu -v > trace_version.txt 2>&1

echo.                                  >> "%FILE_TRACE%"
echo Fichier trace_version.txt         >> "%FILE_TRACE%"
echo.                                  >> "%FILE_TRACE%"
echo --------------     >> "%FILE_TRACE%"
type trace_version.txt  >> "%FILE_TRACE%"
echo --------------     >> "%FILE_TRACE%"


rem for /F "usebackq delims=:( tokens=1,2,3" %%i in (trace_version.txt) do (
rem set RESULTAT=%%j)
rem 
rem 
rem for /F "usebackq tokens=1,2" %%p in (`echo %RESULTAT%`) do (
rem set VERSION_NUMBER=%%q)

rem  Recuperation du message dans une variablr
for /F "usebackq tokens=*" %%i in (trace_version.txt) do (
set LIGNE_VERSION=%%i)


set MOT=%LIGNE_VERSION%

rem echo MOT : %MOT% 
rem echo.


copy trace_version.txt ligne.txt >NUL


rem Boucle d'extraction de chaque mot du message (ligne de texte contenant le numero de version)
rem MOT   : contient le premier mot du message
rem RESTE : contient les autres mots du message
rem
rem A chaque interation : on examine le message 
rem - le premier mot est extrait, 
rem - le reste des mots forment le message a examiner pour la prochaine iteration
rem
rem
rem
rem

set RESTE=XXXXXXXXXXXXXXXX

:PARSE_VERSION


rem Plus de mots a examiner : erreur
if "%RESTE%" == "" goto ERR_HPU_VERSION

rem Extraction du premier mot et du reste du message
for /F "tokens=1,*" %%i in (ligne.txt) do (
set MOT=%%i
set RESTE=%%j
)

rem echo.
rem echo MOT   : %MOT% 
rem echo RESTE : %RESTE% 
rem echo.

rem Pour examiner le mot, placement de celui-ci dans un fichier pour utilsier "findstr"
echo %MOT% > mot.txt



rem Recherche chaine du type "nn.cccc...cc(nnnnn)ccc" dans le mot
rem
rem Apres la chaine elle-meme, il y a d'autres caracteres (CR + LF)
rem findstr "^[0-9][0-9]\..*([0-9][0-9][0-9][0-9][0-9][0-9]).*$" mot.txt
rem Si la chaine n'est pas trouvee, "findstr" ne retourne rien.

rem Si le "findstr" ne retourne rien, le traitement du "for" n'est pas
rem execute et RESULTAT contient encore la valeur de l'iteration precedente.
set RESULTAT=

for /F "tokens=*" %%v in ('findstr "^[0-9][0-9]\..*([0-9][0-9][0-9][0-9][0-9][0-9]).*$" mot.txt') do (
set RESULTAT=%%v)


rem echo Resultat de recherche : %RESULTAT%
if not "%RESULTAT%" == "" goto VER_FOUND

rem pause
rem echo.
rem echo.

rem Constitution du message a examiner pour iteration suivante
echo %RESTE% > ligne.txt

goto PARSE_VERSION



:VER_FOUND

echo Found version information : >> "%FILE_TRACE%"
echo RESULTAT : "%RESULTAT%"     >> "%FILE_TRACE%"




rem Extraction du numero de version "nn.nn.nnn" a partir de la chaine "nn.nn.nnn(nnnnnn)"
for /F "usebackq delims=() tokens=1,2,3" %%p in ("mot.txt") do (
set VERSION_NUMBER=%%p )



echo.                                    >> "%FILE_TRACE%"
echo VERSION_NUMBER : "%VERSION_NUMBER%" >> "%FILE_TRACE%"

rem Suppression espace superflu en fin (cause presence inconnue)
set VERSION_NUMBER=%VERSION_NUMBER:~0,-1%

echo VERSION_NUMBER : "%VERSION_NUMBER%" >> "%FILE_TRACE%"



rem 
rem Controle de la compatibilite entre version et update
rem 



rem Indentation bizarre sinon erreurs de syntaxe

if "%VERSION_NUMBER%" GTR "%VERSION_UPDATE%"  (echo Version %VERSION_NUMBER% is too high to apply update %UPDATE_LABEL%
    echo Version %VERSION_NUMBER% is too high to apply update %UPDATE_LABEL% >> "%FILE_TRACE%"
    goto END) else (
     if "%VERSION_NUMBER%" EQU "%VERSION_UPDATE%"  (echo Version %VERSION_NUMBER% is already installed
         echo Version %VERSION_NUMBER% is already installed >> "%FILE_TRACE%"
         goto END) else (          
          if "%VERSION_NUMBER%" LSS "%VERSION_UPDATE_BASE%" (echo Version %VERSION_NUMBER% is too low to apply update %UPDATE_LABEL%
               echo Version %VERSION_NUMBER% is too low to apply update %UPDATE_LABEL% >> "%FILE_TRACE%"
               goto END) else (
            echo Found version %VERSION_NUMBER%, update %UPDATE_LABEL% to version %VERSION_UPDATE% can be applied
            echo Found version %VERSION_NUMBER%, update %UPDATE_LABEL% to version %VERSION_UPDATE% can be applied  >> "%FILE_TRACE%")
       )
 )


goto SUITE_INSTALL


:CHECK_UNINST_VERSION

rem
rem >>> Fichier temporaire trace_version.txt a supprimer !!!!
rem

rem Appel de db2hpu avec CALL sinon pas de continuation du script aprs

call db2hpu -v > trace_version.txt 2>&1

echo.                                  >> "%FILE_TRACE%"
echo Fichier trace_version.txt         >> "%FILE_TRACE%"
echo.                                  >> "%FILE_TRACE%"
echo --------------     >> "%FILE_TRACE%"
type trace_version.txt  >> "%FILE_TRACE%"
echo --------------     >> "%FILE_TRACE%"


rem for /F "usebackq delims=:( tokens=1,2,3" %%i in (trace_version.txt) do (
rem set RESULTAT=%%j)
rem 
rem 
rem for /F "usebackq tokens=1,2" %%p in (`echo %RESULTAT%`) do (
rem set VERSION_NUMBER=%%q)

rem  Recuperation du message dans une variable
for /F "usebackq tokens=*" %%i in (trace_version.txt) do (
set LIGNE_VERSION=%%i)


set MOT=%LIGNE_VERSION%

rem echo MOT : %MOT% 
rem echo.


copy trace_version.txt ligne.txt >NUL


rem Boucle d'extraction de chaque mot du message (ligne de texte contenant le numero de version)
rem MOT   : contient le premier mot du message
rem RESTE : contient les autres mots du message
rem
rem A chaque interation : on examine le message 
rem - le premier mot est extrait, 
rem - le reste des mots forment le message a examiner pour la prochaine iteration
rem
rem
rem
rem

set RESTE=XXXXXXXXXXXXXXXX

:PARSE_VERSION


rem Plus de mots a examiner : erreur
if "%RESTE%" == "" goto ERR_HPU_VERSION

rem Extraction du premier mot et du reste du message
for /F "tokens=1,*" %%i in (ligne.txt) do (
set MOT=%%i
set RESTE=%%j
)

rem echo.
rem echo MOT   : %MOT% 
rem echo RESTE : %RESTE% 
rem echo.

rem Pour examiner le mot, placement de celui-ci dans un fichier pour utilsier "findstr"
echo %MOT% > mot.txt



rem Recherche chaine du type "nn.cccc...cc(nnnnn)ccc" dans le mot
rem
rem Apres la chaine elle-meme, il y a d'autres caracteres (CR + LF)
rem findstr "^[0-9][0-9]\..*([0-9][0-9][0-9][0-9][0-9][0-9]).*$" mot.txt
rem Si la chaine n'est pas trouvee, "findstr" ne retourne rien.

rem Si le "findstr" ne retourne rien, le traitement du "for" n'est pas
rem execute et RESULTAT contient encore la valeur de l'iteration precedente.
set RESULTAT=

for /F "tokens=*" %%v in ('findstr "^[0-9][0-9]\..*([0-9][0-9][0-9][0-9][0-9][0-9]).*$" mot.txt') do (
set RESULTAT=%%v)


rem echo Resultat de recherche : %RESULTAT%
if not "%RESULTAT%" == "" goto VER_FOUND

rem pause
rem echo.
rem echo.

rem Constitution du message a examiner pour iteration suivante
echo %RESTE% > ligne.txt

goto PARSE_VERSION



:VER_FOUND

echo Found version information : >> "%FILE_TRACE%"
echo RESULTAT : "%RESULTAT%"     >> "%FILE_TRACE%"




rem Extraction du numero de version "nn.nn.nnn" a partir de la chaine "nn.nn.nnn(nnnnnn)"
for /F "usebackq delims=() tokens=1,2,3" %%p in ("mot.txt") do (
set VERSION_NUMBER=%%p )



echo.                                    >> "%FILE_TRACE%"
echo VERSION_NUMBER : "%VERSION_NUMBER%" >> "%FILE_TRACE%"

rem Suppression espace superflu en fin (cause presence inconnue)
set VERSION_NUMBER=%VERSION_NUMBER:~0,-1%

echo VERSION_NUMBER : "%VERSION_NUMBER%" >> "%FILE_TRACE%"



rem 
rem Controle de la compatibilite entre version et update
rem 



rem Indentation bizarre sinon erreurs de syntaxe

if "%VERSION_NUMBER%" GTR "%VERSION_UPDATE%"  (echo Current version %VERSION_NUMBER% is too high to uninstall the update %UPDATE_LABEL%
    echo Current version %VERSION_NUMBER% is too high to uninstall the update %UPDATE_LABEL% >> "%FILE_TRACE%"
    goto END) else (
     if "%VERSION_NUMBER%" LSS "%VERSION_UPDATE%"  (echo Current version %VERSION_NUMBER% is older than update %UPDATE_LABEL%!
         echo Uninstallation impossible
         echo Current version %VERSION_NUMBER% is older than update %UPDATE_LABEL%! >> "%FILE_TRACE%"
         echo Uninstallation impossible >> "%FILE_TRACE%"
         goto END) else (          
          if "%VERSION_NUMBER%" EQU "%VERSION_UPDATE%" (echo Current version is %VERSION_NUMBER%, uninstallation of %UPDATE_LABEL% can be done.
               echo Current version is %VERSION_NUMBER%, uninstallation of %UPDATE_LABEL% can be done. >> "%FILE_TRACE%")
       )
 )


goto SUITE_UNINSTALL


rem #######################################################################
rem # Installation
rem #######################################################################

:SUITE_INSTALL

rem Liste des mises-a-jour deja installees
rem 
rem Methode utilisee : liste des fichiers executables db2hpum_debug_XXXX
rem Pb : les noms sont des noms de abreges pour les noms de fichiers et ne sont pas
rem les noms officiels des mises-a-jour.  
rem
rem Non realise


echo/ 
echo -------------------------------------------------------------------
echo/ 
echo High Performance Unload
echo/
echo %UPDATE_CATEGORY% %UPDATE_LABEL% for Windows operating system
echo/ 
echo/ 
echo -------------------------------------------------------------------


echo/ 
echo The update will be applied to the version located at 
echo %TOPHPU%
echo/ 


echo/                                     >> "%FILE_TRACE%"
echo Context                : "%CONTEXT%" >> "%FILE_TRACE%"
echo/                                     >> "%FILE_TRACE%"




echo All replaced files will be renamed by adding the "_%UPDATE_LABEL%" extension
echo. 
echo You must be the "Administrator" user in order to run this update
echo The HPU network service must be stopped
echo.

:ANSWER_INST

echo Type "install" to continue or "quit" to abort:
echo. (The answer is case sensitive)
echo.

set /p RESPONSE=

echo RESPONSE : "%RESPONSE%" >> "%FILE_TRACE%"
echo.

if "%RESPONSE%" == "install" goto CONT_INST
if "%RESPONSE%" == "quit" goto ABORT_INST

goto ANSWER_INST

:CONT_INST




echo/               
echo Installing...  

echo/               >> "%FILE_TRACE%"
echo Installing...  >> "%FILE_TRACE%"



rem ############
rem Desarchivage
rem ############

echo/               
echo Extracting files from archive...  


rem Controle presence fichier archive

echo Checking file archive_update_win32.zip >> "%FILE_TRACE%"
if not exist archive_update_win32.zip goto ERR_NOT_FOUND

rem Extraction fichiers archive

echo Extracting archive...  >> "%FILE_TRACE%"

"%TOPHPU%\install\unzip" -o archive_update_win32.zip  >> "%FILE_TRACE%"

rem Utiliser rpertoire temporaire ??? (il faut modifier tous les chemins !!)


rem ### DEBUG ###
rem del archive_update_win32.zip
rem ### FIN DEBUG ###





rem ####################
rem Recopie des fichiers
rem ####################

rem


cd /d "%DIR_UPDATE%"


echo.
echo Updating files...
echo.

echo/                   >> "%FILE_TRACE%"
echo ==========================================================================  >> "%FILE_TRACE%"
echo Updating files...  >> "%FILE_TRACE%"
echo/                   >> "%FILE_TRACE%"

for /f %%a in (
 update_list.txt
) do (
  echo.                      >> "%FILE_TRACE%"
  if exist "%%a" (
       echo File "%TOPHPU%\%%a" >> "%FILE_TRACE%"
       if exist "%TOPHPU%\%%a" (
       echo Existing file found.  >> "%FILE_TRACE%"
       echo.                      >> "%FILE_TRACE%"
       echo Backing up file...    >> "%FILE_TRACE%"
       
       rem Pas d'utilisation de rename car probleme pour obtenir le second argument conforme
       rem a la syntaxe de la commande (nom seul sans chemin)
       rem rename "%TOPHPU%\%%a" "%TOPHPU%\%%a_XXX"
       copy "%TOPHPU%\%%a" "%TOPHPU%\%%a_%UPDATE_LABEL%"  >> "%FILE_TRACE%"
       
       echo.                    >> "%FILE_TRACE%"
       echo Copying new file... >> "%FILE_TRACE%"
       copy "%DIR_UPDATE%\%%a" "%TOPHPU%\%%a"  >> "%FILE_TRACE%"
    
       )  else (
       echo No actual file found. >> "%FILE_TRACE%"
       echo.                      >> "%FILE_TRACE%"
       echo Copying new file...   >> "%FILE_TRACE%"
       copy "%DIR_UPDATE%\%%a" "%TOPHPU%\%%a"  >> "%FILE_TRACE%"
       )
   )  else (
       echo File "%%a" from archive not found! >> "%FILE_TRACE%"
       echo File "%%a" from archive not found!
       )

)



rem ######################
rem Mise-a-jour du plug-in
rem ######################

echo.
echo Updating plug-in...
echo.

echo ==========================================================================  >> "%FILE_TRACE%"
echo Updating plug-in  >> "%FILE_TRACE%"
echo.                  >> "%FILE_TRACE%"

cd /d "%TOPHPU%\java"

echo Backing up classes  >> "%FILE_TRACE%"
xcopy classes classes_%UPDATE_LABEL%  /i/v/s/e  >> "%FILE_TRACE%"

echo Updating classes  >> "%FILE_TRACE%"
xcopy "%DIR_UPDATE%\java\classes" classes /i/v/s/e/y  >> "%FILE_TRACE%"


cd classes

echo.               >> "%FILE_TRACE%"

echo Removing actual classes in ZIP archive file >> "%FILE_TRACE%"
"%TOPHPU%\install\zip" -rq "%DB2_DIR%\db2plug.zip" -d com\ibm\inz*  >> "%FILE_TRACE%"



echo Adding updated classes in ZIP archive file >> "%FILE_TRACE%"
"%TOPHPU%\install\zip" -r0D "%DB2_DIR%\db2plug.zip" *  >> "%FILE_TRACE%"










rem ########################################
rem Creation repertoire pour desinstallation
rem ########################################

echo.
echo Creating uninstall directory...
echo.

echo ==========================================================================  >> "%FILE_TRACE%"
echo Creating uninstall directory >> "%FILE_TRACE%"

echo.

if exist "%TOPHPU%\ptf" (
  echo Creating directory "%TOPHPU%\ptf\%UPDATE_LABEL%" >> "%FILE_TRACE%"
  mkdir "%TOPHPU%\ptf\%UPDATE_LABEL%"
 ) else (
   echo Creating directory ptf "%TOPHPU%\ptf" >> "%FILE_TRACE%"
   mkdir "%TOPHPU%\ptf" 
   echo Creating directory "%TOPHPU%\ptf\%UPDATE_LABEL%" >> "%FILE_TRACE%"
   mkdir "%TOPHPU%\ptf\%UPDATE_LABEL%"
 ) 

 
rem Recopie des fichiers

echo Populating files in "%TOPHPU%\ptf\%UPDATE_LABEL%" directory >> "%FILE_TRACE%"

copy "%DIR_UPDATE%\hpu_update.bat" "%TOPHPU%\ptf\%UPDATE_LABEL%" >> "%FILE_TRACE%"
copy "%DIR_UPDATE%\uninstall_update_hpu.bat" "%TOPHPU%\ptf\%UPDATE_LABEL%" >> "%FILE_TRACE%"

copy "%DIR_UPDATE%\update_list.txt" "%TOPHPU%\ptf\%UPDATE_LABEL%" >> "%FILE_TRACE%"
copy "%DIR_UPDATE%\update_variables.txt" "%TOPHPU%\ptf\%UPDATE_LABEL%" >> "%FILE_TRACE%"
copy "%DIR_UPDATE%\InstallInstructions.txt" "%TOPHPU%\ptf\%UPDATE_LABEL%" >> "%FILE_TRACE%"
copy "%DIR_UPDATE%\GetRegistry.exe" "%TOPHPU%\ptf\%UPDATE_LABEL%" >> "%FILE_TRACE%"

 



echo.                       
echo Installation completed 
echo.                      



echo.                       >> "%FILE_TRACE%"
echo Installation completed >> "%FILE_TRACE%"
echo.                       >> "%FILE_TRACE%"


goto END






rem #######################################################################
rem # Desinstallation
rem #######################################################################

:SUITE_UNINSTALL


rem Liste des mises-a-jour deja installees
rem 
rem Methode utilisee : liste des fichiers executables db2hpum_debug_XXXX
rem Pb : les noms sont des noms de abreges pour les noms de fichiers et ne sont pas
rem les noms officiels des mises-a-jour.  
rem
rem Non realise


echo/ 
echo -------------------------------------------------------------------
echo/ 
echo High Performance Unload
echo/
echo %UPDATE_CATEGORY% %UPDATE_LABEL% for Windows operating system
echo/ 
echo/ 
echo -------------------------------------------------------------------

echo/ 
echo The update will be removed from the version located at 
echo %TOPHPU%
echo/ 


echo. 
echo You must be the "Administrator" user in order to run this update
echo The HPU network service must be stopped
echo.

:ANSWER_UNINST

echo Type "uninstall" to continue or "quit" to abort:
echo. (The answer is case sensitive)
echo.

set /p RESPONSE=

echo RESPONSE : "%RESPONSE%" >> "%FILE_TRACE%"
echo.

if "%RESPONSE%" == "uninstall" goto CONT_UNINST
if "%RESPONSE%" == "quit" goto ABORT_UNINST

goto ANSWER_UNINST

:CONT_UNINST



echo/               
echo Uninstalling...

echo/                 >> "%FILE_TRACE%"
echo Uninstalling...  >> "%FILE_TRACE%"

rem 


rem #########################
rem Restauration des fichiers
rem #########################

echo.
echo Restoring files...
echo.


echo ==========================================================================  >> "%FILE_TRACE%"
echo Restoring files >> "%FILE_TRACE%"


cd /d "%DIR_UPDATE%"


for /f %%a in (
 update_list.txt
) do (
  echo.                    >> "%FILE_TRACE%"
  echo %%a                 >> "%FILE_TRACE%"
  echo.                    >> "%FILE_TRACE%"

   echo File "%TOPHPU%\%%a" >> "%FILE_TRACE%"  
      
   if exist "%TOPHPU%\%%a_%UPDATE_LABEL%" (
   echo Backup file found  >> "%FILE_TRACE%"
   echo.                   >> "%FILE_TRACE%"

   echo Removing actual file >> "%FILE_TRACE%"
   
   del "%TOPHPU%\%%a"  >> "%FILE_TRACE%"

   echo.                          >> "%FILE_TRACE%"
   echo Copying from backup file  >> "%FILE_TRACE%"
   
   rem 
   rem 
   
   copy "%TOPHPU%\%%a_%UPDATE_LABEL%" "%TOPHPU%\%%a"  >> "%FILE_TRACE%"
   
   echo.                     >> "%FILE_TRACE%"
   echo Removing backup file >> "%FILE_TRACE%"
   del "%TOPHPU%\%%a_%UPDATE_LABEL%"  >> "%FILE_TRACE%"

   )  else (
   
   rem Pas de fichier a restaurer : il n'existait pas auparavant 
   rem (difference avec le traitement sous UNIX)
   echo Backup file not found.  >> "%FILE_TRACE%"
   echo.                        >> "%FILE_TRACE%"  
   if exist "%TOPHPU%\%%a" (
   echo Removing actual file...   >> "%FILE_TRACE%"
   del "%TOPHPU%\%%a"  >> "%FILE_TRACE%"
   
   ) else (
      echo Actual file "%TOPHPU%\%%a" not found! >> "%FILE_TRACE%"
     )
   )
  
)




rem #######################
rem Restauration du plug-in
rem #######################

echo.
echo Restoring plug-in...
echo.


echo ==========================================================================  >> "%FILE_TRACE%"
echo Restoring plug-in >> "%FILE_TRACE%"


cd /d "%TOPHPU%\java"

echo Removing classes directory >> "%FILE_TRACE%"
rmdir /s/q classes  >> "%FILE_TRACE%"

echo.                            >> "%FILE_TRACE%"
echo Restoring classes directory >> "%FILE_TRACE%"
xcopy "classes_%UPDATE_LABEL%" classes /i/v/s/e  >> "%FILE_TRACE%"

echo.                                  >> "%FILE_TRACE%"
echo Removing unused classes directory >> "%FILE_TRACE%"
rmdir  /s/q  "classes_%UPDATE_LABEL%"


cd classes
 
echo.                                             >> "%FILE_TRACE%"
echo Removal of classes files in ZIP archive file >> "%FILE_TRACE%"
"%TOPHPU%\install\zip" -rq "%DB2_DIR%\db2plug.zip" -d com\ibm\inz*  >> "%FILE_TRACE%"



echo.                                    >> "%FILE_TRACE%"
echo Adding classes files in ZIP archive >> "%FILE_TRACE%"
"%TOPHPU%\install\zip" -r0D "%DB2_DIR%\db2plug.zip" *  >> "%FILE_TRACE%"





echo.                         
echo Uninstallation completed 
echo.                         

echo.                         >> "%FILE_TRACE%"
echo Uninstallation completed >> "%FILE_TRACE%"
echo.                         >> "%FILE_TRACE%"



goto END







rem #######################################################################
rem #  
rem #######################################################################

:ERR_HPU_VERSION
echo Error while determining DB2 version >> "%FILE_TRACE%"
echo Error while determining DB2 version
goto END





:ABORT_INST
echo Aborting installation >> "%FILE_TRACE%"
echo Aborting installation
goto END


:ABORT_UNINST
echo Aborting uninstallation >> "%FILE_TRACE%"
echo Aborting uninstallation
goto END



:ERR_CFG
echo Error file "%TOPHPU%\cfg\db2hpu.cfg" not found >> "%FILE_TRACE%"
echo Error file "%TOPHPU%\cfg\db2hpu.cfg" not found
goto END


:ERR_DB2_VERSION
echo Error while determining DB2 version >> "%FILE_TRACE%"
echo Error while determining DB2 version
goto END


:ERR_PARAM
echo Bad parameters
goto END


:ERR_PAR1
echo Parameter 1 must be "INST" or "UNINST"
goto END


:ERR_CONTEXT
echo Error on context value : %CONTEXT% >> "%FILE_TRACE%"
echo Error on context value : %CONTEXT%
goto END


:ERR_NOT_FOUND
echo Archive file not found >> "%FILE_TRACE%"
echo Archive file not found
goto END


:ERR_DOS
echo Unknown DOS version >> "%FILE_TRACE%"
echo Unknown DOS version
goto END
  
  
:ERR_DB2_LOCATION
echo Error while determining DB2 location >> "%FILE_TRACE%"
echo Error while determining DB2 location
goto END




:END
  
